(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);throw new Error("Cannot find module '"+o+"'")}var f=n[o]={exports:{}};t[o][0].call(f.exports,function(e){var n=t[o][1][e];return s(n?n:e)},f,f.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var keycode = require('keycode');
var scan = require('./scan.js')();
var pencil = require('svg-pencil');
var svgSelect = require('svg-select');

var timeline = require('editor-timeline')(200);
timeline.appendTo('#timeline');

var toolbox = require('./toolbox.js')();
toolbox.appendTo('#workspace');

var shift = false, inputtingText;
window.addEventListener('click', function (ev) {
    var tag = String(ev.target.tagName).toLowerCase();
    inputtingText = /^(input|textarea)$/.test(tag);
});
window.addEventListener('blur', function (ev) {
    inputtingText = false;
});
window.addEventListener('keydown', function (ev) {
    shift = ev.shiftKey;
    if (inputtingText) return;
    var chr = keycode(ev);
    if (chr === 'k') createMark();
    if (chr === 's') toolbox.select('select');
    if (chr === 'p') toolbox.select('pencil');
    if (chr === 'delete') {
        if (toolbox.current === 'select') {
            var sel = canvas[currentMark.id].sel;
            var e = sel.selected;
            e.parentNode.removeChild(e);
            sel.selected = null;
        }
        else {
            timeline.removeMark('_active');
        }
    }
    if (chr === 'home') { stop(); timeline.setTime(0) }
    if (chr === 'space') timeline.toggle();
    if (chr === 'left') { stop(); timeline.select('prev') }
    if (chr === 'right') { stop(); timeline.select('next') }
    
    function stop () {
        ev.stopPropagation();
        ev.preventDefault();
    }
});
window.addEventListener('keyup', function (ev) {
    shift = ev.shiftKey;
});
toolbox.on('K', createMark);
toolbox.on('back', function () { timeline.setTime(0) });
toolbox.on('play', function () { timeline.toggle() });

toolbox.on('click', function (button, name) {
    var keys = Object.keys(canvas);
    for (var i = 0; i < keys.length; i++) {
        var k = keys[i];
        if (name === 'pencil') canvas[k].enable();
        else canvas[k].disable();
    }
});

timeline.on('start', function () {
    toolbox.buttons.play.textContent = '||';
});
timeline.on('stop', function () {
    toolbox.buttons.play.textContent = '>';
});

timeline.on('show', function (mark) {
    if (currentMark) canvas[currentMark.id].hide();
    canvas[mark.id].show();
    currentMark = mark;
});

timeline.on('remove', function (mark) {
    var e = canvas[mark.id].element;
    e.parentNode.removeChild(e);
    delete canvas[mark.id];
    if (currentMark === mark) currentMark = undefined;
});

timeline.on('mark', function (m, elem) { scan(elem) });

function createMark () {
    var m = timeline.mark();
    m.on('click', function () {
        if (currentMark) canvas[currentMark.id].hide();
        canvas[m.id].show();
        currentMark = m;
    });
    
    if (currentMark && shift) {
        canvas[m.id] = pencil.parse(canvas[currentMark.id].toSource());
    }
    else {
        canvas[m.id] = pencil();
    }
    if (currentMark) {
        canvas[currentMark.id].hide();
    }
    canvas[m.id].appendTo('#canvas');
    currentMark = m;
    timeline.select(m.id);
    
    var c = canvas[m.id], down = false, last;
    var sel = svgSelect(c.element);
    c.sel = sel;
    
    sel.disable();
    sel.on('select', function (p) {
        p.style.stroke = 'red';
    });
    sel.on('blur', function (p) {
        p.style.stroke = 'black';
    });
    c.on('path', function (p) {
        p.style.strokeWidth = 4;
    });
    
    window.addEventListener('mousedown', function (ev) {
        last = ev;
        down = true;
    });
    window.addEventListener('mouseup', function (ev) { down = false });
    window.addEventListener('mousemove', function (ev) {
        if (!down) return;
        var dx = last ? ev.clientX - last.clientX : 0;
        var dy = last ? ev.clientY - last.clientY : 0;
        last = ev;
        if (!sel.enabled) return;
        if (!sel.selected) return;
        var parts = sel.selected.getAttribute('d').split(/\s+/);
        sel.selected.setAttribute('d', parts.map(function (x) {
            if (/^[\d.]+,[\d.]+$/.test(x)) {
                var s = x.split(',');
                var x = Number(s[0]) + dx;
                var y = Number(s[1]) + dy;
                return x + ',' + y;
            }
            return x;
        }).join(' '));
    });
    
    c.on('enable', function () { sel.disable() });
    c.on('disable', function () { sel.enable(); down = false });
}

var canvas = {}, currentMark;
createMark();
toolbox.select('pencil');
scan(document);

},{"./scan.js":2,"./toolbox.js":3,"editor-timeline":9,"keycode":21,"svg-pencil":22,"svg-select":24}],2:[function(require,module,exports){
var classList = require('class-list');

module.exports = function () {
    var moving = [], last;
    window.addEventListener('mousemove', function (ev) {
        var dx = last ? ev.clientX - last.clientX : 0;
        var dy = last ? ev.clientY - last.clientY : 0;
        for (var i = 0; i < moving.length; i++) moving[i].on(dx, dy);
        last = ev;
    });
    window.addEventListener('mouseup', function (ev) {
        for (var i = 0; i < moving.length; i++) moving[i].off();
        moving = [];
    });
    
    return function scan (root) {
        var elems = root.querySelectorAll('*[x-drag]')
        if (root.getAttribute && root.getAttribute('x-drag') !== undefined) {
            elems = [].slice.call(elems).concat(root);
        }
        
        for (var i = 0; i < elems.length; i++) (function (elem) {
            var target = elem;
            var tclist = classList(elem);
            var tstyle = window.getComputedStyle(target);
            var tpos = { x: parseInt(tstyle.left), y: parseInt(tstyle.top) };
            
            var handles = elem.querySelectorAll('*[x-drag-handle]');
            if (handles.length === 0) handles = [ elem ];
            
            for (var j = 0; j < handles.length; j++) (function (h) {
                h.addEventListener('mousedown', function () {
                    moving.push({ on: onmove, off: off });
                    tclist.add('dragging');
                });
                function off () { tclist.remove('dragging') }
                function onmove (dx, dy) {
                    target.style.left = (tpos.x += dx);
                    target.style.top = (tpos.y += dy);
                }
            })(handles[j]);
        })(elems[i]);
    };
};

},{"class-list":6}],3:[function(require,module,exports){
var fs = require('fs');
var html = "<div class=\"toolbox window\" x-drag>\n  <div class=\"title\" x-drag-handle>toolbox</div>\n  <button name=\"select\" x-mode=\"top\">S</button>\n  <button name=\"pencil\" x-mode=\"top\">P</button>\n  <button name=\"K\" title=\"Key a frame. Clone the current frame into a new keyframe with shift+k\">K</button>\n  \n  <div class=\"bottom\">\n    <button name=\"back\" class=\"b\">«</button>\n    <button name=\"play\" class=\"b\">&gt;</button>\n    <button name=\"foreward\" class=\"b\">»</button>\n  </div>\n</div>\n";
var domify = require('domify');
var classList = require('class-list');
var inherits = require('inherits');
var EventEmitter = require('events').EventEmitter;

module.exports = Toolbox;
inherits(Toolbox, EventEmitter);

function Toolbox () {
    var self = this;
    if (!(this instanceof Toolbox)) return new Toolbox;
    var div = this.element = domify(html);
    var buttons = div.querySelectorAll('button');
    this.selected = {};
    this.buttons = {};
    
    for (var i = 0; i < buttons.length; i++) (function (button) {
        var name = button.getAttribute('name');
        self.buttons[name] = button;
        
        button.addEventListener('click', function () {
            self.setMode(name);
        });
    })(buttons[i]);
}

Toolbox.prototype.select = function (name) {
    var button = this.buttons[name];
    var mode = button.getAttribute('x-mode');
    this.current = name;
    
    if (mode && this.selected[mode]) {
        this.selected[mode].remove('selected');
    }
    if (mode) {
        this.selected[mode] = classList(button);
        this.selected[mode].add('selected');
    }
    this.emit('click', button, name);
    this.emit(name, button);
};

Toolbox.prototype.appendTo = function (target) {
    if (typeof target === 'string') target = document.querySelector(target);
    target.appendChild(this.element);
};

},{"class-list":6,"domify":8,"events":5,"fs":4,"inherits":20}],4:[function(require,module,exports){

},{}],5:[function(require,module,exports){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

function EventEmitter() {
  this._events = this._events || {};
  this._maxListeners = this._maxListeners || undefined;
}
module.exports = EventEmitter;

// Backwards-compat with node 0.10.x
EventEmitter.EventEmitter = EventEmitter;

EventEmitter.prototype._events = undefined;
EventEmitter.prototype._maxListeners = undefined;

// By default EventEmitters will print a warning if more than 10 listeners are
// added to it. This is a useful default which helps finding memory leaks.
EventEmitter.defaultMaxListeners = 10;

// Obviously not all Emitters should be limited to 10. This function allows
// that to be increased. Set to zero for unlimited.
EventEmitter.prototype.setMaxListeners = function(n) {
  if (!isNumber(n) || n < 0 || isNaN(n))
    throw TypeError('n must be a positive number');
  this._maxListeners = n;
  return this;
};

EventEmitter.prototype.emit = function(type) {
  var er, handler, len, args, i, listeners;

  if (!this._events)
    this._events = {};

  // If there is no 'error' event listener then throw.
  if (type === 'error') {
    if (!this._events.error ||
        (isObject(this._events.error) && !this._events.error.length)) {
      er = arguments[1];
      if (er instanceof Error) {
        throw er; // Unhandled 'error' event
      } else {
        throw TypeError('Uncaught, unspecified "error" event.');
      }
      return false;
    }
  }

  handler = this._events[type];

  if (isUndefined(handler))
    return false;

  if (isFunction(handler)) {
    switch (arguments.length) {
      // fast cases
      case 1:
        handler.call(this);
        break;
      case 2:
        handler.call(this, arguments[1]);
        break;
      case 3:
        handler.call(this, arguments[1], arguments[2]);
        break;
      // slower
      default:
        len = arguments.length;
        args = new Array(len - 1);
        for (i = 1; i < len; i++)
          args[i - 1] = arguments[i];
        handler.apply(this, args);
    }
  } else if (isObject(handler)) {
    len = arguments.length;
    args = new Array(len - 1);
    for (i = 1; i < len; i++)
      args[i - 1] = arguments[i];

    listeners = handler.slice();
    len = listeners.length;
    for (i = 0; i < len; i++)
      listeners[i].apply(this, args);
  }

  return true;
};

EventEmitter.prototype.addListener = function(type, listener) {
  var m;

  if (!isFunction(listener))
    throw TypeError('listener must be a function');

  if (!this._events)
    this._events = {};

  // To avoid recursion in the case that type === "newListener"! Before
  // adding it to the listeners, first emit "newListener".
  if (this._events.newListener)
    this.emit('newListener', type,
              isFunction(listener.listener) ?
              listener.listener : listener);

  if (!this._events[type])
    // Optimize the case of one listener. Don't need the extra array object.
    this._events[type] = listener;
  else if (isObject(this._events[type]))
    // If we've already got an array, just append.
    this._events[type].push(listener);
  else
    // Adding the second element, need to change to array.
    this._events[type] = [this._events[type], listener];

  // Check for listener leak
  if (isObject(this._events[type]) && !this._events[type].warned) {
    var m;
    if (!isUndefined(this._maxListeners)) {
      m = this._maxListeners;
    } else {
      m = EventEmitter.defaultMaxListeners;
    }

    if (m && m > 0 && this._events[type].length > m) {
      this._events[type].warned = true;
      console.error('(node) warning: possible EventEmitter memory ' +
                    'leak detected. %d listeners added. ' +
                    'Use emitter.setMaxListeners() to increase limit.',
                    this._events[type].length);
      console.trace();
    }
  }

  return this;
};

EventEmitter.prototype.on = EventEmitter.prototype.addListener;

EventEmitter.prototype.once = function(type, listener) {
  if (!isFunction(listener))
    throw TypeError('listener must be a function');

  var fired = false;

  function g() {
    this.removeListener(type, g);

    if (!fired) {
      fired = true;
      listener.apply(this, arguments);
    }
  }

  g.listener = listener;
  this.on(type, g);

  return this;
};

// emits a 'removeListener' event iff the listener was removed
EventEmitter.prototype.removeListener = function(type, listener) {
  var list, position, length, i;

  if (!isFunction(listener))
    throw TypeError('listener must be a function');

  if (!this._events || !this._events[type])
    return this;

  list = this._events[type];
  length = list.length;
  position = -1;

  if (list === listener ||
      (isFunction(list.listener) && list.listener === listener)) {
    delete this._events[type];
    if (this._events.removeListener)
      this.emit('removeListener', type, listener);

  } else if (isObject(list)) {
    for (i = length; i-- > 0;) {
      if (list[i] === listener ||
          (list[i].listener && list[i].listener === listener)) {
        position = i;
        break;
      }
    }

    if (position < 0)
      return this;

    if (list.length === 1) {
      list.length = 0;
      delete this._events[type];
    } else {
      list.splice(position, 1);
    }

    if (this._events.removeListener)
      this.emit('removeListener', type, listener);
  }

  return this;
};

EventEmitter.prototype.removeAllListeners = function(type) {
  var key, listeners;

  if (!this._events)
    return this;

  // not listening for removeListener, no need to emit
  if (!this._events.removeListener) {
    if (arguments.length === 0)
      this._events = {};
    else if (this._events[type])
      delete this._events[type];
    return this;
  }

  // emit removeListener for all listeners on all events
  if (arguments.length === 0) {
    for (key in this._events) {
      if (key === 'removeListener') continue;
      this.removeAllListeners(key);
    }
    this.removeAllListeners('removeListener');
    this._events = {};
    return this;
  }

  listeners = this._events[type];

  if (isFunction(listeners)) {
    this.removeListener(type, listeners);
  } else {
    // LIFO order
    while (listeners.length)
      this.removeListener(type, listeners[listeners.length - 1]);
  }
  delete this._events[type];

  return this;
};

EventEmitter.prototype.listeners = function(type) {
  var ret;
  if (!this._events || !this._events[type])
    ret = [];
  else if (isFunction(this._events[type]))
    ret = [this._events[type]];
  else
    ret = this._events[type].slice();
  return ret;
};

EventEmitter.listenerCount = function(emitter, type) {
  var ret;
  if (!emitter._events || !emitter._events[type])
    ret = 0;
  else if (isFunction(emitter._events[type]))
    ret = 1;
  else
    ret = emitter._events[type].length;
  return ret;
};

function isFunction(arg) {
  return typeof arg === 'function';
}

function isNumber(arg) {
  return typeof arg === 'number';
}

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}

function isUndefined(arg) {
  return arg === void 0;
}

},{}],6:[function(require,module,exports){
// contains, add, remove, toggle
var indexof = require('indexof')

module.exports = ClassList

function ClassList(elem) {
    var cl = elem.classList

    if (cl) {
        return cl
    }

    var classList = {
        add: add
        , remove: remove
        , contains: contains
        , toggle: toggle
        , toString: $toString
        , length: 0
        , item: item
    }

    return classList

    function add(token) {
        var list = getTokens()
        if (indexof(list, token) > -1) {
            return
        }
        list.push(token)
        setTokens(list)
    }

    function remove(token) {
        var list = getTokens()
            , index = indexof(list, token)

        if (index === -1) {
            return
        }

        list.splice(index, 1)
        setTokens(list)
    }

    function contains(token) {
        return indexof(getTokens(), token) > -1
    }

    function toggle(token) {
        if (contains(token)) {
            remove(token)
            return false
        } else {
            add(token)
            return true
        }
    }

    function $toString() {
        return elem.className
    }

    function item(index) {
        var tokens = getTokens()
        return tokens[index] || null
    }

    function getTokens() {
        var className = elem.className

        return filter(className.split(" "), isTruthy)
    }

    function setTokens(list) {
        var length = list.length

        elem.className = list.join(" ")
        classList.length = length

        for (var i = 0; i < list.length; i++) {
            classList[i] = list[i]
        }

        delete list[length]
    }
}

function filter (arr, fn) {
    var ret = []
    for (var i = 0; i < arr.length; i++) {
        if (fn(arr[i])) ret.push(arr[i])
    }
    return ret
}

function isTruthy(value) {
    return !!value
}

},{"indexof":7}],7:[function(require,module,exports){

var indexOf = [].indexOf;

module.exports = function(arr, obj){
  if (indexOf) return arr.indexOf(obj);
  for (var i = 0; i < arr.length; ++i) {
    if (arr[i] === obj) return i;
  }
  return -1;
};
},{}],8:[function(require,module,exports){

/**
 * Expose `parse`.
 */

module.exports = parse;

/**
 * Wrap map from jquery.
 */

var map = {
  legend: [1, '<fieldset>', '</fieldset>'],
  tr: [2, '<table><tbody>', '</tbody></table>'],
  col: [2, '<table><tbody></tbody><colgroup>', '</colgroup></table>'],
  _default: [0, '', '']
};

map.td =
map.th = [3, '<table><tbody><tr>', '</tr></tbody></table>'];

map.option =
map.optgroup = [1, '<select multiple="multiple">', '</select>'];

map.thead =
map.tbody =
map.colgroup =
map.caption =
map.tfoot = [1, '<table>', '</table>'];

map.text =
map.circle =
map.ellipse =
map.line =
map.path =
map.polygon =
map.polyline =
map.rect = [1, '<svg xmlns="http://www.w3.org/2000/svg" version="1.1">','</svg>'];

/**
 * Parse `html` and return the children.
 *
 * @param {String} html
 * @return {Array}
 * @api private
 */

function parse(html) {
  if ('string' != typeof html) throw new TypeError('String expected');
  
  // tag name
  var m = /<([\w:]+)/.exec(html);
  if (!m) return document.createTextNode(html);

  html = html.replace(/^\s+|\s+$/g, ''); // Remove leading/trailing whitespace

  var tag = m[1];

  // body support
  if (tag == 'body') {
    var el = document.createElement('html');
    el.innerHTML = html;
    return el.removeChild(el.lastChild);
  }

  // wrap map
  var wrap = map[tag] || map._default;
  var depth = wrap[0];
  var prefix = wrap[1];
  var suffix = wrap[2];
  var el = document.createElement('div');
  el.innerHTML = prefix + html + suffix;
  while (depth--) el = el.lastChild;

  // one element
  if (el.firstChild == el.lastChild) {
    return el.removeChild(el.firstChild);
  }

  // several elements
  var fragment = document.createDocumentFragment();
  while (el.firstChild) {
    fragment.appendChild(el.removeChild(el.firstChild));
  }

  return fragment;
}

},{}],9:[function(require,module,exports){
var cursor = require('./lib/cursor.js');
var classList = require('class-list');
var Mark = require('./lib/mark.js');
var inherits = require('inherits');
var EventEmitter = require('events').EventEmitter;
var insertCss = require('insert-css');
var fs = require('fs');

insertCss(".editor-timeline {\n  position: relative;\n  background-color: rgb(50,50,50);\n  border: 1px solid white;\n  height: 100%;\n  width: 100%;\n  overflow-x: scroll;\n  -moz-user-select: none;\n  -khtml-user-select: none;\n  -webkit-user-select: none;\n  -ms-user-select: none;\n  user-select: none;\n}\n\n.editor-timeline .cursor {\n  position: absolute;\n  top: 0px;\n  bottom: 0px;\n  left: 0px;\n  padding-left: 2px;\n  border-left-width: 2px;\n  border-left-color: rgb(127,127,127);\n  border-left-style: solid;\n  color: rgb(127,127,127);\n}\n\n.editor-timeline .cursor.active {\n  border-left-color: white;\n  color: white;\n}\n\n.editor-timeline .mark {\n  cursor: hand;\n  position: absolute;\n  bottom: 0px;\n  left: 0px;\n  width: 15px;\n  height: 15px;\n  background-color: rgb(180,20,240);\n}\n\n.editor-timeline .mark:hover {\n  background-color: rgb(220,80,220);\n}\n\n.editor-timeline .mark.active {\n  background-color: rgb(140,240,20);\n}\n\n.editor-timeline .mark.dragging {\n  cursor: move;\n}\n");

module.exports = Timeline;
inherits(Timeline, EventEmitter);

function Timeline (pxps) {
    var self = this;
    if (!(this instanceof Timeline)) return new Timeline(pxps);
    var div = this.element = document.createElement('div');
    classList(div).add('editor-timeline');
    div.style.height = '100%';
    div.style.minWidth = (pxps * 60 * 2) + 'px';
    
    this.pixelsPerSecond = pxps;
    this.active = cursor('active', pxps).appendTo(div);
    this.hover = cursor('hover', pxps).appendTo(div);
    this.active.setTime(0);
    
    this.hover.hide();
    this.marks = [];
    this._listen(div);
}

Timeline.prototype.appendTo = function (target) {
    if (typeof target === 'string') target = document.querySelector(target);
    target.appendChild(this.element);
    return this;
};

Timeline.prototype.mark = function () {
    var self = this;
    var m = Mark(this.active.left.copy());
    m.id = Math.floor(Math.random() * Math.pow(16,8)).toString(16);
    m.on('click', function (div) { self.select(m.id) });
    m.on('seconds', function (sec) {
        for (var i = 0; i < self._marks; i++) {
            if (self.marks[i] === m) {
                self.marks.splice(i, 1);
                insert(m);
            }
        }
    });
    
    insert(m);
    
    m.appendTo(this.element);
    this.emit('mark', m, m.element);
    return m;
    
    function insert () {
        // todo binary search whatever
        for (var i = 0; i < self.marks.length; i++) {
            if (m.getSeconds() < self.marks[i].getSeconds()) {
                self.marks.splice(i, 0, m);
                return;
            }
        }
        self.marks.push(m);
    }
};

Timeline.prototype._markIndex = function (id) {
    for (var i = 0; i < this.marks.length; i++) {
        if (this.marks[i].id === id) return i;
    }
    return -1;
};

Timeline.prototype.select = function (id) {
    var ix;
    if (id === 'next') {
        ix = this._markIndex(this._activeMark) + 1;
    }
    else if (id === 'prev') {
        ix = this._markIndex(this._activeMark) - 1;
    }
    else {
        ix = this._markIndex(id);
    }
    var m = this.marks[ix];
    if (!m) return;
    
    var prev = this.marks[this._current];
    if (prev) classList(prev.element).remove('active');
    this._current = ix;
    
    classList(m.element).add('active');
    this._activeMark = m.id;
    
    this.active.setTime(m.getSeconds());
    this.emit('show', m, ix);
};

Timeline.prototype.removeMark = function (m) {
    if (m === '_active') m = this._activeMark;
    if (!m) return false;
    for (var i = 0; i < this.marks.length; i++) {
        if (this.marks[i].id === m) {
            this.emit('remove', this.marks[i], i);
            this.element.removeChild(this.marks[i].element);
            this.marks.splice(i, 1);
            var n = this.marks[i-1] || this.marks[0];
            if (n) this.select(n.id);
            return true;
        }
    }
    return false;
};

Timeline.prototype.start = function () {
    if (this._started) return;
    var self = this;
    this._started = Date.now();
    this._offset = this.active.getSeconds();
    
    window.requestAnimationFrame(function f () {
        if (!self._started) return;
        self._tick();
        window.requestAnimationFrame(f);
    });
    this.emit('start');
};

Timeline.prototype._findNearest = function (x) {
    for (var i = 0; i < this.marks.length; i++) {
        var m = this.marks[i];
        if (x <= m.getSeconds()) {
            return i === 0 ? 0 : i - 1;
        }
    }
    return this.marks.length - 1;
};

Timeline.prototype._setNearest = function (sec) {
    var i = this._findNearest(sec);
    var prev = this._current;
    this._current = i;
    if (prev !== i) {
        var m = this.marks[i];
        var p = this.marks[this._current];
        if (!m) return;
        if (p) classList(p.element).remove('active');
        classList(m.element).add('active');
        this._activeMark = m.id;
        this.emit('show', this.marks[i], i);
    }
    return i;
};

Timeline.prototype._tick = function () {
    var t = this._offset + (Date.now() - this._started) / 1000;
    this.active.setTime(t);
    var m = this.marks[this._current + 1];
    if (!m) return;
    if (t >= m.getSeconds()) {
        var p = this.marks[this._current];
        if (p) classList(p.element).remove('active');
        classList(m.element).add('active');
        this._activeMark = m.id;
        this._current ++;
        this.emit('show', m, this._current);
    }
};

Timeline.prototype.stop = function () {
    if (!this._started) return;
    this._started = 0;
    this.emit('stop');
};

Timeline.prototype.toggle = function () {
    if (this._started) this.stop()
    else this.start()
};

Timeline.prototype.setTime = function (x) {
    var p = this.marks[this._current];
    if (p) classList(p.element).remove('active');
    this.active.setTime(x);
    this._setNearest(x);
};

Timeline.prototype.getTime = function () {
    return this.active.getSeconds();
};

Timeline.prototype._listen = function (div) {
    var self = this;
    div.addEventListener('mouseover', function (ev) {
        self.hover.show();
    });
    
    div.addEventListener('mouseout', function (ev) {
        self.hover.hide();
    });
    
    div.addEventListener('mousemove', function (ev) {
        var sx = div.getBoundingClientRect().left;
        self.hover.setPixels(ev.clientX - this.offsetLeft - sx);
        self.hover.show();
    });
    
    div.addEventListener('click', function (ev) {
        var sx = div.getBoundingClientRect().left;
        self.active.setPixels(ev.clientX - this.offsetLeft - sx);
        self._setNearest(self.getTime());
    });
};

},{"./lib/cursor.js":10,"./lib/mark.js":12,"class-list":15,"events":5,"fs":4,"inherits":18,"insert-css":19}],10:[function(require,module,exports){
var fs = require('fs');
var html = "<div class=\"cursor\">\n  <div class=\"time\">00:00</div>\n</div>\n";
var domify = require('domify');
var classList = require('class-list');
var formatTime = require('./time/format.js');
var Left = require('./left.js');

module.exports = Cursor;

function Cursor (name, pxps) {
    var self = this;
    if (!(this instanceof Cursor)) return new Cursor(name, pxps);
    this.element = domify(html);
    this.classList = classList(this.element);
    if (name) this.classList.add(name);
    
    this.left = Left(pxps);
    this.left.on('left', function (px) {
        self.element.style.left = px;
    });
    this.left.on('seconds', function (seconds) {
        self.element.textContent = formatTime(seconds);
    });
}

Cursor.prototype.appendTo = function (target) {
    if (typeof target === 'string') target = document.querySelector(target);
    target.appendChild(this.element);
    return this;
};

Cursor.prototype.hide = function () {
    this.element.style.display = 'none';
};

Cursor.prototype.show = function () {
    this.element.style.display = 'block';
};

Cursor.prototype.setTime = function (time) {
    this.left.setTime(time);
};

Cursor.prototype.getSeconds = function () {
    return this.left.seconds || 0;
};

Cursor.prototype.setPixels = function (px) {
    this.left.setPixels(px);
};

},{"./left.js":11,"./time/format.js":13,"class-list":15,"domify":17,"fs":4}],11:[function(require,module,exports){
var parseTime = require('./time/parse.js');
var inherits = require('inherits');
var EventEmitter = require('events').EventEmitter;

module.exports = Left;
inherits(Left, EventEmitter);

function Left (pxps) {
    if (!(this instanceof Left)) return new Left(pxps);
    this.pixelsPerSecond = pxps;
}

Left.prototype.appendTo = function (target) {
    if (typeof target === 'string') target = document.querySelector(target);
    target.appendChild(this.element);
    return this;
};

Left.prototype.setScale = function (pxps) {
    this.pixelsPerSecond = pxps;
    if (this._lastPixels) this.setPixels(this._lastPixels);
    else if (this._lastTime) this.setTime(this._lastTime);
};

Left.prototype.setTime = function (time) {
    this._lastPixels = null;
    this._lastTime = time;
    var seconds = typeof time === 'number' ? time : parseTime(time);
    this.seconds = seconds;
    this.px = seconds * this.pixelsPerSecond;
    this.emit('seconds', this.seconds);
    this.emit('left', this.px);
};

Left.prototype.setPixels = function (px) {
    if (typeof px === 'string') px = parseInt(px);
    this._lastPixels = px;
    this._lastTime = null;
    
    this.seconds = px / this.pixelsPerSecond;
    this.px = px;
    this.emit('seconds', this.seconds);
    this.emit('left', this.px);
};

Left.prototype.copy = function () {
    var x = new Left(this.pixelsPerSecond);
    if (this.seconds) x.setTime(this.seconds);
    return x;
};

},{"./time/parse.js":14,"events":5,"inherits":18}],12:[function(require,module,exports){
var fs = require('fs');
var html = "<div class=\"mark\" x-drag></div>\n";
var domify = require('domify');
var Left = require('./left.js');
var inherits = require('inherits');
var EventEmitter = require('events').EventEmitter;

module.exports = Mark;
inherits(Mark, EventEmitter);

function Mark (pos) {
    var self = this;
    if (!(this instanceof Mark)) return new Mark(pos);
    
    this.pos = pos;
    var div = this.element = domify(html);
    div.addEventListener('click', function (ev) {
        ev.stopPropagation();
        self.emit('click', div);
    });
    
    div.addEventListener('mousedown', function (ev) {
        window.addEventListener('mouseup', mouseup);
        function mouseup () {
            pos.setPixels(div.style.left);
            window.removeEventListener('mouseup', mouseup);
        }
    });
    
    if (pos.px) self.element.style.left = pos.px;
    
    pos.on('left', function (px) {
        self.element.style.left = px;
    });
    pos.on('seconds', function (sec) {
        self.emit('seconds', sec);
    });
}

Mark.prototype.appendTo = function (target) {
    if (typeof target === 'string') target = document.querySelector(target);
    target.appendChild(this.element);
};

Mark.prototype.getSeconds = function () {
    return this.pos.seconds || 0;
};

},{"./left.js":11,"domify":17,"events":5,"fs":4,"inherits":18}],13:[function(require,module,exports){
module.exports = function (s) {
    var parts = [ Math.floor(s / 60 % 60), Math.floor(s % 60) ].map(pad);
    if (s > 60 * 60) parts.unshift(Math.floor(s / 60 / 60));
    return parts.join(':');
};
function pad (n) { return n < 10 ? '0' + n : String(n) }

},{}],14:[function(require,module,exports){
module.exports = function (str) { 
    var seconds = 0;
    var parts = str.split(':');
    for (var i = 0, len = parts.length; i < len; i++) {
        seconds += Number(parts[i]) * Math.pow(60, len - i - 1);
    }
    return seconds;
};

},{}],15:[function(require,module,exports){
module.exports=require(6)
},{"indexof":16}],16:[function(require,module,exports){
module.exports=require(7)
},{}],17:[function(require,module,exports){
module.exports=require(8)
},{}],18:[function(require,module,exports){
if (typeof Object.create === 'function') {
  // implementation from standard node.js 'util' module
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor
    ctor.prototype = Object.create(superCtor.prototype, {
      constructor: {
        value: ctor,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
  };
} else {
  // old school shim for old browsers
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor
    var TempCtor = function () {}
    TempCtor.prototype = superCtor.prototype
    ctor.prototype = new TempCtor()
    ctor.prototype.constructor = ctor
  }
}

},{}],19:[function(require,module,exports){
var inserted = {};

module.exports = function (css) {
    if (inserted[css]) return;
    inserted[css] = true;
    
    var elem = document.createElement('style');
    elem.setAttribute('type', 'text/css');

    if ('textContent' in elem) {
      elem.textContent = css;
    } else {
      elem.styleSheet.cssText = css;
    }
    
    var head = document.getElementsByTagName('head')[0];
    head.appendChild(elem);
};

},{}],20:[function(require,module,exports){
module.exports=require(18)
},{}],21:[function(require,module,exports){
// Source: http://jsfiddle.net/vWx8V/
// http://stackoverflow.com/questions/5603195/full-list-of-javascript-keycodes

var has = ({}).hasOwnProperty

/**
 * Conenience method returns corresponding value for given keyName or keyCode.
 *
 * @param {Mixed} keyCode {Number} or keyName {String}
 * @return {Mixed}
 * @api public
 */

exports = module.exports = function(searchInput) {
  // Keyboard Events
  if (searchInput && 'object' === typeof searchInput) {
    var hasKeyCode = searchInput.which || searchInput.keyCode || searchInput.charCode
    if (hasKeyCode) searchInput = hasKeyCode
  }

  // Numbers
  if ('number' === typeof searchInput) return names[searchInput]

  // Everything else (cast to string)
  var search = String(searchInput)

  // check codes
  var foundNamedKey = codes[search.toLowerCase()]
  if (foundNamedKey) return foundNamedKey

  // check aliases
  var foundNamedKey = aliases[search.toLowerCase()]
  if (foundNamedKey) return foundNamedKey

  // weird character?
  if (search.length === 1) return search.charCodeAt(0)

  return undefined
}

/**
 * Get by name
 *
 *   exports.code['enter'] // => 13
 */

var codes = exports.code = exports.codes = {
  'backspace': 8,
  'tab': 9,
  'enter': 13,
  'shift': 16,
  'ctrl': 17,
  'alt': 18,
  'pause/break': 19,
  'caps lock': 20,
  'esc': 27,
  'space': 32,
  'page up': 33,
  'page down': 34,
  'end': 35,
  'home': 36,
  'left': 37,
  'up': 38,
  'right': 39,
  'down': 40,
  'insert': 45,
  'delete': 46,
  'windows': 91,
  'right click': 93,
  'numpad *': 106,
  'numpad +': 107,
  'numpad -': 109,
  'numpad .': 110,
  'numpad /': 111,
  'num lock': 144,
  'scroll lock': 145,
  'my computer': 182,
  'my calculator': 183,
  ';': 186,
  '=': 187,
  ',': 188,
  '-': 189,
  '.': 190,
  '/': 191,
  '`': 192,
  '[': 219,
  '\\': 220,
  ']': 221,
  "'": 222
}

// Helper aliases

var aliases = exports.aliases = {
  'ctl': 17,
  'pause': 19,
  'break': 19,
  'caps': 20,
  'escape': 27,
  'pgup': 33,
  'pgdn': 33,
  'ins': 45,
  'del': 46,
  'spc': 32
}


/*!
 * Programatically add the following
 */

// lower case chars
for (i = 97; i < 123; i++) codes[String.fromCharCode(i)] = i - 32

// numbers
for (var i = 48; i < 58; i++) codes[i - 48] = i

// function keys
for (i = 1; i < 13; i++) codes['f'+i] = i + 111

// numpad keys
for (i = 0; i < 10; i++) codes['numpad '+i] = i + 96

/**
 * Get by code
 *
 *   exports.name[13] // => 'Enter'
 */

var names = exports.names = exports.title = {} // title for backward compat

// Create reverse mapping
for (i in codes) names[codes[i]] = i

// Add aliases
for (var alias in aliases) {
  codes[alias] = aliases[alias]
}

},{}],22:[function(require,module,exports){
var EventEmitter = require('events').EventEmitter;
var inherits = require('inherits');

module.exports = Pencil;
inherits(Pencil, EventEmitter);

function Pencil (opts) {
    if (!(this instanceof Pencil)) return new Pencil(opts);
    if (!opts) opts = {};
    if (typeof opts === 'string') opts = { svg: opts };
    this.enabled = true;
    
    var svg = opts.svg || createElement('svg');
    if (typeof svg === 'string') {
        svg = document.querySelector(opts.svg);
    }
    this.element = svg;
    this.path = null;
    this.points = [];
    
    this.fill = opts.fill || 'none';
    this.stroke = opts.stroke || 'black';
    this.strokeWidth = opts.strokeWidth || '1px';
    
    var self = this;
    this.root = opts.root || window;
    this.listeners = {
        mousedown: function (ev) { self._onmousedown(ev) },
        mouseup: function (ev) { self._onmouseup(ev) },
        mousemove: function (ev) { self._onmousemove(ev) }
    };
    this.element.addEventListener('mousedown', this.listeners.mousedown);
    this.root.addEventListener('mouseup', this.listeners.mouseup);
    this.root.addEventListener('mousemove', this.listeners.mousemove);
}

Pencil.prototype.unregister = function () {
    this.element.removeEventListener('mousedown', this.listeners.mousedown);
    this.root.removeEventListener('mouseup', this.listeners.mouseup);
    this.root.removeEventListener('mousemove', this.listeners.mousemove);
};

Pencil.prototype.enable = function () {
    if (this.enabled) return;
    this.enabled = true;
    this.emit('enable');
};

Pencil.prototype.disable = function () {
    if (!this.enable) return;
    this.enabled = false;
    this.emit('disable');
};

Pencil.prototype._onmousedown = function (ev) {
    if (!this.enabled) return;
    var x = ev.offsetX, y = ev.offsetY;
    
    this.points = [ [ x, y ] ];
    this.path = createElement('path');
    this.path.setAttribute('style', [
        'fill:' + this.fill,
        'stroke:' + this.stroke,
        'stroke-width:' + this.strokeWidth
    ].join(';'));
    
    this.emit('point', this.points[0]);
    
    this._setPoints();
    this.emit('path', this.path);
    
    this.element.appendChild(this.path);
};

Pencil.prototype._onmouseup = function (ev) {
    if (!this.enabled) return;
    if (!this.path) return;
    this.emit('points', this.points);
    this.points = [];
    this.path = null;
};

Pencil.prototype._onmousemove = function (ev) {
    if (!this.enabled) return;
    if (!this.path) return;
    
    var pt = [ ev.offsetX, ev.offsetY ];
    this.emit('point', pt);
    this.points.push(pt);
    this._setPoints();
};

Pencil.prototype._setPoints = function () {
    this.path.setAttribute('d', 'M ' + this.points.join(' L '));
};

Pencil.prototype.toSource = function () {
    var div = document.createElement('div');
    div.appendChild(this.element.cloneNode(true));
    return div.innerHTML;
};

Pencil.prototype.appendTo = function (target) {
    if (typeof target === 'string') {
        target = document.querySelector(target);
    }
    target.appendChild(this.element);
};

Pencil.prototype.hide = function () {
    if (this._hidden) return;
    this._hidden = true;
    var style = window.getComputedStyle(this.element);
    this._size = { width: style.width, height: style.height };
    this.element.style.width = 0;
    this.element.style.height = 0;
};

Pencil.prototype.show = function () {
    if (!this._hidden) return;
    this._hidden = false;
    this.element.style.width = this._size.width;
    this.element.style.height = this._size.height;
};

function createElement (name) {
    return document.createElementNS('http://www.w3.org/2000/svg', name);
}

Pencil.parse = function (src) {
    var div = document.createElement('div');
    div.innerHTML = src;
    return new Pencil({ svg: div.querySelector('svg') });
};

},{"events":5,"inherits":23}],23:[function(require,module,exports){
module.exports=require(18)
},{}],24:[function(require,module,exports){
var inherits = require('inherits');
var EventEmitter = require('events').EventEmitter;

module.exports = Select;
inherits(Select, EventEmitter);

function Select (svg) {
    if (!(this instanceof Select)) return new Select(svg);
    var self = this;
    this.svg = svg;
    this.enabled = true;
    
    svg.addEventListener('mousedown', function (ev) {
        if (!self.enabled) return;
        var tag = String(ev.target.tagName).toLowerCase();
        if (tag === 'path') {
            if (self.selected) self.blur();
            self.selected = ev.target;
            self.emit('select', self.selected, ev);
        }
        else self.blur(ev);
    });
}

Select.prototype.enable = function () {
    this.enabled = true;
};

Select.prototype.disable = function () {
    this.enabled = false;
    this.blur();
};

Select.prototype.blur = function (ev) {
    if (!this.selected) return;
    var s = this.selected;
    this.selected = null;
    this.emit('blur', s, ev);
};

},{"events":5,"inherits":25}],25:[function(require,module,exports){
module.exports=require(18)
},{}]},{},[1])